Skip to main content

Dynamic Programming - Easy Level - Question 2

Dynamic Programming - Easy Level - Question 2


Leetcode 62 Unique Paths

A robot is located at the top-left corner of a m x n grid (marked 'Start' in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked 'Finish' in the diagram below).

How many possible unique paths are there?

Constraints:

1 <= m, n <= 100

It's guaranteed that the answer will be less than or equal to 2 * 10^9.


Analysis:


We can apply the same idea in Question1 to the current one, which is from 1D to 2D.

One of the key information is: the robot can only go down or right. So if we define f[i][j] means the total number of ways to reach this position, then

f[i][j] = f[i-1][j] + f[i][j-1]

The first term on the right side is for "go right", and the second for "go down".

After having the state definition and transition formula, we just need to figure out the initial states' values.

Obviously the first row and the first column should always be 1, since there are only one way to reach them.

To simplify the code, usually we can define an extra row & column, and then just need to define f[1][1] = 1, which is enough for the initialization.


See the code below:


class Solution {
public:
    int uniquePaths(int m, int n) {
        vector<vector<int>> dp(m+1, vector<int>(n+1, 0));
        dp[1][1] = 1;
        for(int i=1; i<=m; ++i) {
            for(int j=1; j<=n; ++j) {
                if(i==1 && j==1) continue;
                dp[i][j] = dp[i-1][j] + dp[i][j-1];
            }
        }
        return dp[m][n];
    }
};

Both time and space complexity is O(m*n). The space complexity can be further reduced down to O(n) with the so-called "rolling array" idea, which is explained in the following,

The scanning order for the code above is top-down, and then for each row, it is from left to right. For each dp[i][j], we need its left neighbor and top neighbor. So if we reduce the 2D dp to 1D, we still need to scan from left to right (not the reverse). Why?

In the 2D dp case, when we calculate dp[i][j], dp[i][j-1] has been calculated at the current row; if we use 1D dp, scanning from left to right will use the updated dp[j-1], but scanning from right to left will use the un-updated dp[j-1], or the one from the previous loop. In this question, we need the updated one, so scan from left to right is needed.


See the code below:


class Solution {
public:
    int uniquePaths(int m, int n) {
        vector<int> dp(n, 1);
        for(int i=1; i<m; ++i) {
            for(int j=1; j<n; ++j) {
                dp[j] += dp[j-1];
            }
        }
        return dp[n-1];
    }
};

Note:

Like the Fibonacci sequence, this question also has directly mathematical formula: it is just like the permutation of  m color1 boxes with n color2 boxes, which is (m+n)!/(m!*n!). Such as small world, isn't it?


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...